// WFrame.cpp
// Copyright 1998, William Bull

#include "WFrame.h"

WFrame::WFrame(BView *which)
{
	min_height = min_width = -1;
	max_height = max_width = -1;
	left_style = right_style = USE_NONE;
	top_style = bottom_style = USE_NONE;
	left_relation = top_relation = EDGE_ADJACENT;
	right_relation = bottom_relation = EDGE_ADJACENT;
	left_view = top_view = 0;
	right_view = bottom_view = 0;
	if (which == 0) {
		left_value = right_value = 0;
		top_value = bottom_value = 0;
	} else {
		left_value = which->Frame().left;
		right_value = which->Frame().right;
		top_value = which->Frame().top;
		bottom_value = which->Frame().bottom;
	}
}

WFrame::~WFrame()
{ }

// Set(EDGE_LEFT, USE_NONE)
// Set(EDGE_LEFT, USE_DELTA, 10)
void WFrame::Set(ulong whichEdge,
			ulong whichRelation,
			float howMuch)
{
	if ((whichRelation != USE_NONE) &&
		 (whichRelation != USE_DELTA)) return;

	switch (whichEdge)
	{
		case EDGE_LEFT:
			left_relation = whichRelation;
			if (whichRelation == USE_DELTA) left_value = howMuch;
			break;
		case EDGE_TOP:
			top_relation = whichRelation;
			if (whichRelation == USE_DELTA) top_value = howMuch;
			break;
		case EDGE_RIGHT:
			right_relation = whichRelation;
			if (whichRelation == USE_DELTA) right_value = howMuch;
			break;
		case EDGE_BOTTOM:
			bottom_relation = whichRelation;
			if (whichRelation == USE_DELTA) bottom_value = howMuch;
			break;
	}
}

// Set(EDGE_LEFT, USE_PARENT, USE_LITERAL, 10)
// Set(EDGE_LEFT, USE_PARENT, USE_PERCENTAGE, 50)
void WFrame::Set(ulong whichEdge,
				ulong whichRelation,
				ulong whichViewRelation,
				float howMuch)
{
	if (whichRelation != USE_PARENT) return;

	switch (whichEdge)
	{
		case EDGE_LEFT:
			left_relation = whichRelation;
			left_style = whichViewRelation;
			left_value = howMuch;
			break;
		case EDGE_TOP:
			top_relation = whichRelation;
			top_style = whichViewRelation;
			top_value = howMuch;
			break;
		case EDGE_RIGHT:
			right_relation = whichRelation;
			right_style = whichViewRelation;
			right_value = howMuch;
			break;
		case EDGE_BOTTOM:
			bottom_relation = whichRelation;
			bottom_style = whichViewRelation;
			bottom_value = howMuch;
			break;
	}
}

// Set(EDGE_LEFT, USE_SIBLING, BView*, USE_ADJACENT, 5)
// Set(EDGE_LEFT, USE_SIBLING, BView*, USE_OPPOSITE, 5)
// Set(EDGE_LEFT, USE_SIBLING, BView*, USE_PERCENTAGE, 50)
void WFrame::Set(ulong whichEdge,
				ulong whichRelation,
				BView *whichView,
				ulong whichViewRelation,
				float howMuch)
{
	if (whichRelation != USE_SIBLING) return;

	switch(whichEdge)
	{
		case EDGE_LEFT:
			left_view = whichView;
			left_relation = whichRelation;
			left_style = whichViewRelation;
			left_value = howMuch;
			break;
		case EDGE_TOP:
			top_view = whichView;
			top_relation = whichRelation;
			top_style = whichViewRelation;
			top_value = howMuch;
			break;
		case EDGE_RIGHT:
			right_view = whichView;
			right_relation = whichRelation;
			right_style = whichViewRelation;
			right_value = howMuch;
			break;
		case EDGE_BOTTOM:
			bottom_view = whichView;
			bottom_relation = whichRelation;
			bottom_style = whichViewRelation;
			bottom_value = howMuch;
			break;
	}
}

