// WLayoutWindow.cpp
// Simple example of how the layout manager is communicated to with a window.

#include "WLayoutWindow.h"

WLayoutWindow::WLayoutWindow(BRect frame,
							const char *title, 
							window_type type,
							uint32 flags,
							uint32 workspace)
		: BWindow(frame, title, type, flags, workspace)
{
	manager = new WEdgeManager();
}


WLayoutWindow::~WLayoutWindow()
{
	delete manager;
}

void WLayoutWindow::FrameResized(float new_width, float new_height)
{
	manager->Layout(Bounds());
}

void WLayoutWindow::Show()
{
	manager->Layout(Bounds());
	BWindow::Show();
}
